/**
  ******************************************************************************
  * File Name          : main.c
  * Description        : Main program body
  ******************************************************************************
  *
  * COPYRIGHT(c) 2016 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "stm32f3xx_hal.h"
#include "adc.h"
#include "dma.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/
#define ADCAvgLength 4						// ړς̒
#define ADCAvgIndexMask 3					// ړϗpf[^CfbNXXVp}XN

// ADϊpϐ
__IO uint16_t adc_raw_data[6]; 				// DMA]p̃f[^
__IO uint16_t ADCValues[6][ADCAvgLength];	// ړϗp̃f[^
__IO uint16_t ADV[6]={0,0,0,0,0,0};			// ړϒl
__IO uint16_t ADCAvgIndex = 0;				// ړϗpf[^CfbNX

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
void Error_Handler(void);

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/
void LED(uint8_t , uint8_t , uint8_t);

/* USER CODE END PFP */

/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

int main(void)
{

  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* Configure the system clock */
  SystemClock_Config();

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_ADC1_Init();
  MX_TIM1_Init();
  MX_TIM2_Init();
  MX_USART1_UART_Init();
  MX_USART2_UART_Init();
  MX_USART3_UART_Init();

  /* USER CODE BEGIN 2 */
  /*
   * LEDpPWMo͊Jn
  */
  HAL_TIM_Base_Start(&htim1); // TIM1X^[g
  HAL_TIM_PWM_Start(&htim1, TIM_CHANNEL_1); // TIM1_CH1(LED) PWMo͊Jn
  HAL_TIM_PWM_Start(&htim1, TIM_CHANNEL_2); // TIM1_CH2(LED) PWMo͊Jn
  HAL_TIM_PWM_Start(&htim1, TIM_CHANNEL_3); // TIM1_CH3(LED) PWMo͊Jn

  // Γ_
  LED(0, 100, 0);

  /*
   * ADϊX^[g
   */
  HAL_ADC_Start_DMA(&hadc1, (uint32_t *)adc_raw_data, 6);

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  uint8_t message[64];	// uart1Mf[^
  uint8_t length;		// uart1Mf[^̒
  uint8_t count = 0;
  uint8_t red=100, green=0;;

  while (1)
  {
  /* USER CODE END WHILE */

  /* USER CODE BEGIN 3 */
	  // obej^̒lƃ`lP̒l𕶎ɏo
	  length = sprintf((char*)message, "Vbat=%d adc0=%d\r\n", ADV[4], ADV[0] );
	  // uart1當f[^𑗐M
	  HAL_UART_Transmit(&huart1, message, length, 3);

	  // ADV[0]̒lɂĐLED̖邳ݒ
	  red = ADV[0]/32;
	  if(red>100)	red=100;

	  // LED̖邳ݒ
	  green = 100 - red;

	  // tJ[LED̓_
	  if(count)	LED(red, green, 0);
	  else		LED(0,0,0);

	  // 100[ms]x
	  HAL_Delay(100);
	  count = (count+1) & 0x1;
  }
  /* USER CODE END 3 */

}

/** System Clock Configuration
*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;
  RCC_PeriphCLKInitTypeDef PeriphClkInit;

  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL6;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;
  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_1) != HAL_OK)
  {
    Error_Handler();
  }

  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_USART1|RCC_PERIPHCLK_TIM1
                              |RCC_PERIPHCLK_ADC1;
  PeriphClkInit.Usart1ClockSelection = RCC_USART1CLKSOURCE_PCLK1;
  PeriphClkInit.Tim1ClockSelection = RCC_TIM1CLK_HCLK;
  PeriphClkInit.Adc1ClockSelection = RCC_ADC1PLLCLK_DIV4;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }

  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 1, 2);
}

/* USER CODE BEGIN 4 */
/*
 * RGBxwLED_
 * RGBx0~100
 */
void LED(uint8_t r, uint8_t g, uint8_t b)
{
	htim1.Instance->CCR1 = (uint32_t)r * 100;
	htim1.Instance->CCR2 = (uint32_t)g * 100;
	htim1.Instance->CCR3 = (uint32_t)b * 100;
}

/*
 * ADϊI荞݁iDMAgpj
 */
void HAL_ADC_ConvCpltCallback (ADC_HandleTypeDef* hadc)
{
	// lۑ
	ADCValues[0][ADCAvgIndex] = adc_raw_data[0];
	ADCValues[1][ADCAvgIndex] = adc_raw_data[1];
	ADCValues[2][ADCAvgIndex] = adc_raw_data[2];
	ADCValues[3][ADCAvgIndex] = adc_raw_data[3];
	ADCValues[4][ADCAvgIndex] = adc_raw_data[4];
	ADCValues[5][ADCAvgIndex] = adc_raw_data[5];

	// ϒlvZĕۑ
	ADV[0] = (ADCValues[0][0] + ADCValues[0][1] + ADCValues[0][2] + ADCValues[0][3]) / 4;
	ADV[1] = (ADCValues[1][0] + ADCValues[1][1] + ADCValues[1][2] + ADCValues[1][3]) / 4;
	ADV[2] = (ADCValues[2][0] + ADCValues[2][1] + ADCValues[2][2] + ADCValues[2][3]) / 4;
	ADV[3] = (ADCValues[3][0] + ADCValues[3][1] + ADCValues[3][2] + ADCValues[3][3]) / 4;
	ADV[4] = (ADCValues[4][0] + ADCValues[4][1] + ADCValues[4][2] + ADCValues[4][3]) / 4;
	ADV[5] = (ADCValues[5][0] + ADCValues[5][1] + ADCValues[5][2] + ADCValues[5][3]) / 4;

	ADCAvgIndex = (ADCAvgIndex + 1) & ADCAvgIndexMask; // CfbNXXV
}

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler */
  /* User can add his own implementation to report the HAL error return state */
  while(1) 
  {
  }
  /* USER CODE END Error_Handler */ 
}

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
